<?php
/**
 * Calendar 2.0.8a beta - Patched Version (Patch v18)
 * by Michael Lanman / 'Gizzmo' (justgiz@justgizzmo.com)
 * Feb 26, 2007  implemented by TwoHawks with many contributors' customizations
 * http://www.punres.org/viewtopic.php?id=208
 */
/**************************************************
   ########  SET OPTIONS  ##########
1) CONTROL GUEST USER ACCESS VIA FORUM GUEST USER 'READ' SETTING (OFF BY DEFAULT).
   By Default anyone, registered or not, may view the calendar.  Turning This Feature ON Sets guest Permissions according to the Forum "Guest User Group May 'Read' Posts" Setting.
// To turn this On, Remove the comments (double slashes - //) on the 'if statment' at ~Line24 (2 lines).

***************************************************/

define('PUN_ROOT', './');

// require PUN_ROOT.'calendar/header.php';
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'include/parser.php';

$server_timezone = $pun_config['o_server_timezone'];

//if ($pun_user['is_guest'] && $pun_user['g_read_board'] == '0') 
//   message($lang_common['No permission']);

?>

	<script type="text/javascript">
			//To see how many characters where used and to set the limit to 20479 (20 KB)
			function textCounter(field, countfield, maxlimit)
		    {
				if (field.value.length > maxlimit)
				field.value = field.value.substring(0, maxlimit);
				else 
				countfield.value = maxlimit - field.value.length;
			}
			
	</script>


<div class="blocktable">
<?php
//
//do the stuff like viewing topics posts birthdays or events
//
if(isset($view))
{
	if($view == 'topics')
	{
		###########################################################
		###//===============//=================//===============//#
		##//===============// Show Topic List //===============//##
		#//===============//=================//===============//###
		###########################################################

		//Number of topics to display
		$disp_topics = $pun_user['disp_topics'];
		
		//Time zone adjustment
		$diff = (($pun_user['timezone'] - $server_timezone) * 3600)*(-1);
		$datestart += $diff;
		$dateend += $diff;

		$result = $db->query('SELECT id FROM '.$db->prefix.'topics WHERE posted > '.$datestart.' AND posted < '.$dateend);
		$num_replies = $db->num_rows($result);


		// Determine the post offset (based on $_GET['p'])
		$num_pages = ceil(($num_replies) / $disp_topics);

		$p = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];

		$start_from = $disp_topics * ($p - 1);

		$pages = paginate($num_pages, $p, 'calendar.php?view=topics&amp;date='.$year.'.'.$month.'.'.$day);

		// Pulls list of topics for the day
		$result = $db->query('
			SELECT
			 t.id, t.poster, t.subject, t.posted, t.last_post, t.last_post_id, t.last_poster, t.moved_to, t.num_replies, t.closed, t.forum_id
			FROM '.$db->prefix.'topics AS t
			LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=t.forum_id AND fp.group_id='.$pun_user['g_id'].')

			WHERE
				t.posted > '.$datestart.'  AND
				t.posted < '.$dateend.' AND
				(fp.read_forum IS NULL OR fp.read_forum=1)

			ORDER BY posted LIMIT '.$start_from.','.$disp_topics
		) or error('Unable to fetch topic list for forum', __FILE__, __LINE__, $db->error());

?>
        <h2 style="text-align:center"><span><?php echo $lang_calendar['Viewing_Topics']." ".$datestring ?></span></h2>

        <div class="box">

		<table cellspacing="0">
		<thead>
		<tr>
			<th style="white-space: nowrap"><?php echo $lang_common['Topic']?></th>
			<th style="width: 13%; white-space: nowrap"><?php echo $lang_common['Author']?></th>
			<th style="width: 7%; white-space: nowrap"><?php echo $lang_common['Replies']?></th>
			<th style="width: 25%; white-space: nowrap"><?php echo $lang_common['Last post']?></th>
		</tr>
		</thead>
		<tbody>
<?php
		if($db->num_rows($result))
		{
			while ($cur_topic = $db->fetch_assoc($result))
			{
				if ($cur_topic['moved_to'] == null)
					$last_post = '<a href="viewtopic.php?pid='.$cur_topic['last_post_id'].'#p'.$cur_topic['last_post_id'].'">'.format_time($cur_topic['last_post']).'</a><br /> '.$lang_common['by'].' '.pun_htmlspecialchars($cur_topic['last_poster']);
				else
					$last_post = '&nbsp;';

				if ($pun_config['o_censoring'] == '1')
					$cur_topic['subject'] = censor_words($cur_topic['subject']);

				if ($cur_topic['closed'] == '0')
					$subject = '<a href="viewtopic.php?id='.$cur_topic['id'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';
				else
					$subject = '<a class="punclosed" href="viewtopic.php?id='.$cur_topic['id'].'">'.pun_htmlspecialchars($cur_topic['subject']).'</a>';

?>
			<tr class="puntopic">
				<td><?php echo $subject ?></td>
				<td><?php echo pun_htmlspecialchars($cur_topic['poster']) ?></td>
				<td><?php echo ($cur_topic['moved_to'] == null) ? $cur_topic['num_replies'] : '&nbsp;' ?></td>
				<td style="white-space: nowrap"><?php echo $last_post ?></td>
			</tr>
<?php
			}
		}else
			echo"\t\t\t<tr>\n\t\t\t\t<td colspan='4'>".$lang_calendar['No_Topics']."</td>\n\t\t\t</tr>";
?>
			<tr>
				<th colspan='4'> <a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a> </th>
			</tr>
		</tbody>
		</table>
	</div>

<?php
		navigation('topics');
	}
	elseif($view == 'posts')
	{
		##########################################################
		###//===============//================//===============//#
		##//===============// Show Post list //===============//##
		#//===============//================//================ ###
		##########################################################

		//Number of posts to display
		$disp_posts = $pun_user['disp_posts'];

		$result = $db->query('SELECT id FROM '.$db->prefix.'posts WHERE posted > '.$datestart.' AND posted < '.$dateend);
		$num_replies = $db->num_rows($result);
		
		//Time zone adjustment
		$diff = (($pun_user['timezone'] - $server_timezone) * 3600)*(-1);
		$datestart += $diff;
		$dateend += $diff;

		// Determine the post offset (based on $_GET['p'])
		$num_pages = ceil(($num_replies) / $disp_posts);

		$p = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
		$start_from = $disp_posts * ($p - 1);

		$pages = paginate($num_pages, $p, 'calendar.php?view=posts&amp;date='.$year.'.'.$month.'.'.$day);

		// Pulls list of posts for the day
		$result = $db->query('
			SELECT
			 p.id, p.poster, p.poster_id, p.message, p.posted, p.topic_id,
			 t.id as tid, t.subject as tsub, t.forum_id,
			 f.id as fid, f.forum_name as fname

			FROM '.$db->prefix.'posts AS p
			INNER JOIN '.$db->prefix.'topics AS t ON p.topic_id=t.id
			INNER JOIN '.$db->prefix.'forums AS f ON t.forum_id=f.id
			LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].')


			WHERE
				p.posted > '.$datestart.' AND
				p.posted < '.$dateend.' AND
				(fp.read_forum IS NULL OR fp.read_forum=1)

			ORDER BY p.posted LIMIT '.$start_from.','.$disp_posts
		)or error('Unable to fetch topic list for forum', __FILE__, __LINE__, $db->error());

?>
        <h2 style="text-align:center"><span><?php echo $lang_calendar['Viewing_Posts']." ".$datestring ?></span></h2>

        <div class="box">
		<table cellspacing="0">
		<thead>
			<tr>
				<th style="white-space: nowrap">&nbsp;<?php echo $lang_common['Message']?></th>
				<th style="width: 12%"><?php echo $lang_common['Posted']?></th>
				<th style="width: 12%"><?php echo $lang_common['Forum']?></th>
			</tr>
		</thead>
		<tbody>
<?php
		if($db->num_rows($result))
		{
			while ($cur_posts = $db->fetch_assoc($result))
			{
				if (pun_strlen($cur_posts['message']) >= 80)
				{
					$cur_posts['message'] = substr($cur_posts['message'], 0, 79);
					$cur_posts['message'] .= '&hellip;';
				}

?>
			<tr>
				<td>
				<?php echo $lang_common['Topic']?>: <a href="viewtopic.php?id=<?php echo$cur_posts['tid']?>"><?php echo $cur_posts['tsub']?></a><br />
				<?php echo $lang_calendar['Posted_by']?> <a href="profile.php?id=<?php echo$cur_posts['poster_id']?>"><?php echo $cur_posts['poster']?></a><br />

				<div class="box" style="padding:5px; margin:4px;">
					<?php echo $cur_posts['message']?>
					<div style="text-align: right">
						<a href="viewtopic.php?pid=<?php echo$cur_posts['id'].'#p'.$cur_posts['id']?>"><?php echo $lang_calendar['go_to_post']?></a>
					</div>
				</div>
				</td>
				<td class="puncon2cent"><?php echo format_time($cur_posts['posted']) ?></td>
				<td class="puncon1cent"><a href="viewforum.php?id=<?php echo$cur_posts['fid']?>"><?php echo $cur_posts['fname']?></a></td>

			</tr>

<?php			}
		}else
			echo"\t\t\t<tr>\n\t\t\t\t<td colspan='3'>".$lang_calendar['No_Posts']."</td>\n\t\t\t</tr>";
?>
				<tr>
					<th colspan='3'> <a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a> </th>
				</tr>
			</tbody>
			</table>
		</div>
<?php
		navigation('posts');
	}
	elseif($view == 'bday')
	{
		###########################################################
		###//===============//===============//=================//#
		##//===============// Birthday list //=================//##
		#//==================================================// ###
		###########################################################
		require PUN_ROOT.'lang/'.$pun_user['language'].'/profile.php';

		$result = $db->query('SELECT id, username, use_avatar, last_post, registered, birthday, DAYOFMONTH(birthday) as day	FROM '.$db->prefix.'users WHERE DAYOFMONTH(birthday) = '.$day.' AND MONTH(birthday) = '.$month.' ORDER BY username') or error('Unable to fetch birtday list', __FILE__, __LINE__, $db->error());

?>
        <h2 style="text-align:center"><span><?php echo $lang_calendar['Viewing_Bday']." ".$datestring ?></span></h2>

        <div class="box">

		<table cellspacing="0">
		<thead>
			<tr>
				<th style="width: 80px"><?php echo $lang_profile['Avatar']?></th>
				<th style="width: 25%; text-align: center"><?php echo $lang_common['Username']?></th>
				<th style="width: 15%; text-align: center"><?php echo $lang_calendar['Age']?></th>
				<th style="text-align: center"><?php echo $lang_common['Registered']?></th>
			</tr>
		</thead>
		<tbody>

<?php
		if($db->num_rows($result))
		{
			while($bday_list = $db->fetch_assoc($result))
			{
				if ($bday_list['use_avatar'] == '1')
				{
					if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$bday_list['id'].'.gif'))
						$avatar = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$bday_list['id'].'.gif" alt="" />';
					else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$bday_list['id'].'.jpg'))
						$avatar = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$bday_list['id'].'.jpg" alt="" />';
					else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$bday_list['id'].'.png'))
						$avatar = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$bday_list['id'].'.png" alt="" />';
					else
						$avatar = $lang_profile['No avatar'];
				}
				else
					$avatar = $lang_profile['No avatar'];

				list($bday_year,$bday_month,$bday_day) = explode('-', $bday_list['birthday']);
				$age = (strlen($bday_year)!='4')? $lang_profile['Unknown']: $year-$bday_year;
?>
			<tr>
				<td><?php echo $avatar?></td>
				<td style="text-align: center; font-size: 120%"><a href="profile.php?id=<?php echo$bday_list['id']?>"><?php echo $bday_list['username']?></a></td>
				<td style="text-align: center; font-size: 120%"><?php echo $age?></td>
				<td style="text-align: center; font-size: 120%"><?php echo format_time($bday_list['registered'])?></td>
			</tr>
<?php
			}
		}else
			echo"\t\t\t<tr>\n\t\t\t\t<td colspan='4'>".$lang_calendar['No_Bday']."</td>\n\t\t\t</tr>\n";
?>
			<tr>
				<th colspan='4'> <a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a> </th>
			</tr>
		</tbody>
		</table>
	</div>
<?php
		navigation('bday');
	}
	elseif($view == 'event')
	{
		######################################################
		###//===============//=============//==============//#
		##//===============// Events List //==============//##
		#//===============//=============//==============//###
		######################################################

	$stype = (isset($_GET['id']))? 'e.id = '.intval($_GET['id']) : 'dayofmonth(e.date) = '.$day.' AND month(e.date) = '.$month.' AND year(e.date) ='.$year;	
		$result = $db->query('SELECT e.id, e.date, e.title, e.user_id, e.body, u.username as username, u.num_posts as posts, u.registered as reg, g.g_title as group_id FROM '.$db->prefix.'calendar AS e INNER JOIN '.$db->prefix.'users AS u ON e.user_id=u.id LEFT JOIN '.$db->prefix.'groups AS g ON u.group_id=g.g_id WHERE '.$stype) or error('Unable to fetch event list', __FILE__, __LINE__, $db->error());
?>
	<h2 style="text-align:center"><span><?php echo $lang_calendar['Viewing_Event']?></span></h2>
	<div class="box">

		<table cellspacing="0">
<?php
		if($db->num_rows($result))
		{
			while($event_info = $db->fetch_assoc($result))
			{

				//setting up the date info
				$date_part = explode('-',$event_info['date']);
                           //     $date = date("F jS", mktime(0,0,0,$date_part['1'],$date_part['2'], $date_part['0']));

                                  // could have used $datestring but choose do it this way, in case someone wants to use it to
                                  // view all the events in a week or month.
                                  $date = date_str(mktime(0,0,0,$date_part['1'],$date_part['2'], $date_part['0']));

                           //     This is currently not functional
                           //     if($date_part[0]=="0000")
                           //             $date .= ' (Recuring Event)';
                           //     else
                           //       $date .= ' '.$date_part[0].' (Single Day Event)';

                                  $event_info['body'] = parse_message($event_info['body'], 0);
?>

			<tr>
				<th align="center" style="width: 22%"><b><?php echo ' '.$date ?></b></th>
				<th align="left"><b><?php echo $event_info['title'] ?></b></th>
			</tr>
			<tr>
				<td align="left">&nbsp;
				</td>
				<td valign="top">
					<?php echo $event_info['body']?>
					<p style="text-align:right"><?php echo $lang_calendar['added_by']?> <a href="profile.php?id=<?php echo $event_info['user_id']?>"><?php echo pun_htmlspecialchars($event_info['username']) ?></a></p>
				</td>
			</tr>

<?php
			}
		}
		else {
		
				//setting up the date info 
				$date_part = explode('.',$_GET['date']);
                $date = date_str(mktime(0,0,0,$date_part['1'],$date_part['2'], $date_part['0']));

		?>
			<tr>
				<th align="center" width="22%"><b><?php echo ' '.$date ?></b></th>
				<th align="left">&nbsp;</th>
			</tr>
			
			<tr>
				<td align="left">&nbsp;
				</td>
				<td valign="top">
					<?php echo $lang_calendar['No_Events']?>
				</td>
			</tr>
			
			
		<?php
		
            }

?>
			<tr>
				<th colspan='2' align="left"> <a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a> </th>
			</tr>
		</table>

	</div>

<?php
		navigation('event');

	}
}

//
// Do the actions like adding and editing events
//
elseif(isset($action))
{
	if(!
       (($pun_user['g_id'] == PUN_MOD && $CFG_mod_add == 'yes') ||
	    ($pun_user['g_id'] != PUN_GUEST && $CFG_user_add == 'yes' && $pun_user['g_id'] != PUN_MOD) || 
		($pun_user['g_id'] == PUN_ADMIN))
	  )

		message($lang_calendar['warning']);

	elseif($action == 'add')
	{
		#######################################################
		###//===============//==============//==============//#
		##//===============// Add an event //==============//##
		#//===============//==============//==============//###
		#######################################################
		if(isset($_POST['form_sent']))
		{
			// Check to see if the Title, Body, Month, and Day were sent
			if(empty($_POST['title']))
				message($lang_calendar['need_title']);
			elseif(strlen($_POST['title']) > 50 )
				message($lang_calendar['big_title']);
			elseif(empty($_POST['req_message']))
				message($lang_calendar['need_body']);
			elseif(strlen($_POST['req_message']) > 20479 )
				message($lang_calendar['big_body']);
			elseif($_POST['month']=="0" || $_POST['day']=="0")
				message($lang_calendar['need_date']);

			// Clean up body and title from POST
			$title = pun_htmlspecialchars(pun_trim($_POST['title']));
			$body = pun_linebreaks(pun_trim($_POST['req_message']));
     	                $body = preparse_bbcode($body, $errors);

			// Setup the correct date layout for the database
                        if($_POST['year'] == $lang_calendar['Year'])
				$_POST['year'] = date('Y');

			// Check to see of the month and day were set

			// Check to see if the day selected for the month is an actual day
			$year=($_POST['year']=='0000')? date('Y'): $_POST['year'];
			if(date('t', mktime(0,0,0,$_POST['month'],1,$year))< $_POST['day'])
				message($lang_calendar['date_error']);

			$date = $_POST['year'].'-'.$_POST['month'].'-'.$_POST['day'];

			// Add the Event to the database
			$db->query('INSERT INTO '.$db->prefix.'calendar (date, title, body, user_id) VALUES("'.$db->escape($date).'", "'.$db->escape($title).'", "'.$db->escape($body).'", "'.intval($_POST['user_id']).'")') or error('Unable to create new event', __FILE__, __LINE__, $db->error());

			redirect("calendar.php?type=events&amp;date=".$_POST['year'].".".$_POST['month'], $lang_calendar['event_added']);
		}
		else
		{
		
$current_year = date("Y");
$getdate = $_GET['date'];
	           if (!empty($getdate)){
  	             $parts = Explode('.', $getdate);
	             $getyear = $parts[0];
	             $getmonth = $parts[1];
	             $getday = $parts[2];
	           }
		
?>
	<div class="blockform">
	<h2><?php echo $lang_calendar['add_event']?></h2>
	<div class="box">
	<div style="width:100%;float:left;margin-right:-450px">
	<div style="display:inline;float:left;margin-right:450px">
		<form id="post" method="post" action="calendar.php?action=add" onsubmit="return process_form(this)">
            <div class="inform">
                <fieldset style="width: 450px;">					
					<legend><?php echo $lang_calendar['add_info']?></legend>
					<div class="infldset">
						<input type="hidden" name="form_sent" value="1" />
						<input type="hidden" name="user_id" value="<?php echo pun_htmlspecialchars($pun_user['id'])?>" />

						<label class="conl" >
							<strong><?php echo $lang_calendar['Title']?></strong><br />
							<input type="text" name="title" size="30" maxlength="50" /><br />
						</label>
						<label class="conl">
							<strong><?php echo $lang_calendar['Date']?></strong><br />

							<select name="month">
								<option value='0'><?php echo $lang_calendar['Month']?></option>
<?php
	$month_name = array('',$lang_calendar['January'],$lang_calendar['February'],$lang_calendar['March'],$lang_calendar['April'],$lang_calendar['May'],$lang_calendar['June'],$lang_calendar['July'],$lang_calendar['August'],$lang_calendar['September'],$lang_calendar['October'],$lang_calendar['November'],$lang_calendar['December']);
	for($x=1;$x<13;$x++){
	           if (!empty($getdate)){
	                    if ($x==$getmonth){
	                    $slc = " selected='selected'";
	                    }
	                    else {
	                    $slc = "";
	                    }
	           }
	           else {
	                    $slc = "";
	           }
		echo"\t\t\t\t\t\t\t\t<option value='".$x."'$slc>".$month_name[$x]."</option>\n";
		}
?>
							</select>
						</label>
						<label class="conl"><br />
							<select name="day">
								<option value='0'><?php echo $lang_calendar['Day']?></option>
<?php
	for($x=01;$x<=31;$x++){
	           if (!empty($getdate)){
	                    if ($x==$getday){
	                    $slc = " selected='selected'";
	                    }
	                    else {
	                    $slc = "";
	                    }
	           }
	           else {
	                    $slc = "";
	           }
		echo"\t\t\t\t\t\t\t\t<option value='".$x."'$slc>".$x."</option>\n";
		}
?>
							</select>
						</label>
						<label class="conl"><br />
							<select name="year">
<?php
    for($x=($current_year-2);$x<=($current_year+5);$x++){
               if (!empty($getdate)){
                        if ($x==$getyear){
                        $slc = " selected='selected'";
                        }
                        else {
                        $slc = "";
                        }
               }
               else {
                       if ($x==$year){
                        $slc = " selected='selected'";
                        }
                        else {
                        $slc = "";
                        }
               }
        echo"\t\t\t\t\t\t\t\t<option value='".$x."'$slc>".$x."</option>\n";
        }
?>
							</select>
						</label>
						<br  class="clearer" />
						<div class="txtarea">
							<label class="conl">
								<strong><?php echo $lang_calendar['Body']?></strong><br />
								<textarea name="req_message" onkeydown="textCounter(this.form.req_message,this.form.remLen,20478);" rows="25" cols="70" style="width: 425px;"></textarea><br />
							</label>
						<ul class="bblinks">
							<li><a href="help.php#bbcode" onclick="window.open(this.href); return false;"><?php echo $lang_common['BBCode'] ?></a>: <?php echo ($pun_config['p_message_bbcode'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#img" onclick="window.open(this.href); return false;"><?php echo $lang_common['img tag'] ?></a>: <?php echo ($pun_config['p_message_img_tag'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#smilies" onclick="window.open(this.href); return false;"><?php echo $lang_common['Smilies'] ?></a>: <?php echo ($pun_config['o_smilies'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
						</ul>
							
						</div>
						<br class="clearer" />
					</div>
				</fieldset>
			</div>
			<p style="width: 450px;"><input type="submit" value="<?php echo $lang_common['Submit'] ?>" /><a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a></p>
		</form>
	</div>
	</div>

<?php  //this is a cludge, not the real thing used elsewhere
	if($CFG_show_cal == "yes"){
		echo "<div style='float:left;width:215px'>";
		mini_cal($month, $year, "week");
		echo "</div>";
	}
?>

<?php  //this is a cludge, not the real thing used elsewhere
	if($CFG_show_cal == "yes"){
		echo "<div style='float:right;width:215px'>";
		mini_cal($month+3, $year, "week");
		echo "</div>";
	}
?>
	</div>
	</div>
	<br class="clearer" />

		<?php
		}
	}
	elseif($action =='edit')
	{
		########################################################
		###//===============//===============//==============//#
		##//===============// Edit an event //==============//##
		#//===============//===============//==============//###
		########################################################
		if(isset($_POST['form_sent']))
		{
			// Check to see if the Title, Body, Month, and Day were sent
			if(empty($_POST['title']))
				message($lang_calendar['need_title']);
			elseif(strlen($_POST['title']) > 50 )
				message($lang_calendar['big_title']);
			elseif(empty($_POST['req_message']))
				message($lang_calendar['need_body']);
			elseif(strlen($_POST['req_message']) > 20479 )
				message($lang_calendar['big_body']);
			elseif($_POST['month']=="0" || $_POST['day']=="0")
				message($lang_calendar['need_date']);

			// Clean up body and title from POST
			$title = pun_htmlspecialchars(pun_trim($_POST['title']));
			$body = pun_linebreaks(pun_trim($_POST['req_message']));
     	                $body = preparse_bbcode($body, $errors);

			// Setup the correct date layout for the database
			if($_POST['year'] == $lang_calendar['Year'])
				$_POST['year'] = date('Y');

			// Check to see if the month and day were set

			// Check to see if the day selected for the month is an actual day
			$year=($_POST['year']=='0000')? date('Y'): $_POST['year'];
			if(date('t', mktime(0,0,0,$_POST['month'],1,$year))< $_POST['day'])
				message($lang_calendar['date_error']);

			$date = $_POST['year'].'-'.$_POST['month'].'-'.$_POST['day'];

            if (!empty($_POST['page'])){
            $pg = "&amp;p=".$_POST['page'];
            }
            else {
            $pg = "";
            }
            
			// Add the Event to the database
			$db->query('UPDATE '.$db->prefix.'calendar SET date="'.$db->escape($date).'", title="'.$db->escape($title).'", body="'.$db->escape($body).'" WHERE id='.intval($_POST['event_id'])) or error('Unable to Update event', __FILE__, __LINE__, $db->error());

			redirect('calendar.php?action=edit'.$pg.'', $lang_calendar['event_edited']);
		}
		elseif(isset($_POST['delete_event']))
		{
		
            if (!empty($_POST['page'])){

              if (($_POST['tel'] == '1') && ($_POST['page'] != '1')){
              $page = $_POST['page'] - 1;
              }
              else {
              $page = $_POST['page'];
              }
              
              $pg = "&amp;p=".$page;

            }
            
            else {
            $pg = "";
            }
		
			if(isset($_POST['delete_confirmed'])){
				$db->query('DELETE FROM '.$db->prefix.'calendar WHERE id='.intval($_POST['delete_event'])) or error('Unable to delete event', __FILE__, __LINE__, $db->error());

			    if ($_POST['tel'] == '1' && !($_POST['page'] > 1)){
				redirect('calendar.php', $lang_calendar['event_deleted']);
				}
				else{
				redirect('calendar.php?action=edit'.$pg.'', $lang_calendar['event_deleted']);
				}
			}
			else
			{
				if(empty($_POST['event']))
					message($lang_calendar['no_event']);

				$result = $db->query('SELECT date, title, body FROM '.$db->prefix.'calendar WHERE id='.intval($_POST['event'])) or error('Unable to fetch Event info', __FILE__, __LINE__, $db->error());
				$cur_event = $db->fetch_assoc($result);

?>
</div>
<div class="blockform">
	<h2><span><?php echo $lang_common['Info'] ?></span></h2>
	<div class="box">
		<form method="post" action="calendar.php?action=edit">
			<div class="inform">
				<fieldset>
					<legend><?php echo $lang_calendar['delete_confirm'];?></legend>
					<div class="infldset">
						<div class="postmsg">
							<p><b><?php echo pun_htmlspecialchars($cur_event['title']) ?></b></p>
							<p><?php echo pun_htmlspecialchars($cur_event['body'])?></p>
						</div>
					</div>
				</fieldset>
			</div>
			<p>
			<input type="hidden" name="delete_event" value="<?php echo $_POST['event']?>" />
			<input type="hidden" name="page" value="<?php echo $_POST['page'];?>" />
			<input type="hidden" name="tel" value="<?php echo $_POST['tel'];?>" />
			<input type="submit" name="delete_confirmed" value="<?php echo $lang_calendar['delete_yes']?>" />&nbsp;<a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a>
			</p>
		</form>
	</div>
<?php
			}
		}
		elseif(isset($_POST['edit_event']))
		{			
			if(empty($_POST['event']))
				message($lang_calendar['no_event']);

			// Get all the info for the event your trying to edit
			$result = $db->query('SELECT * FROM '.$db->prefix.'calendar WHERE id='.intval($_POST['event'])) or error('Unable to fetch event information', __FILE__, __LINE__, $db->error());
			$event_list = $db->fetch_assoc($result);

			// Get the date info and put it into parts
			$date = explode('-', $event_list['date']);
?>
	<div class="blockform">
	<h2><?php echo $lang_calendar['edit_event']?></h2>
	<div class="box">
	<div style="width:100%;float:left;margin-right:-450px">
	<div style="display:inline;float:left;margin-right:450px">
		<form id="post" method="post" action="calendar.php?action=edit" onsubmit="return process_form(this)">
			<div class="inform">
                <fieldset style="width: 450px;">
					<legend><?php echo $lang_calendar['edit_info']?></legend>
					<div class="infldset">
						<input type="hidden" name="form_sent" value="1" />
						<input type="hidden" name="event_id" value="<?php echo $_POST['event']?>" />

						<label class="conl">
							<strong><?php echo $lang_calendar['Title']?></strong><br />
							<input type="text" value="<?php echo pun_htmlspecialchars($event_list['title']) ?>" name="title" size="30" maxlength="50" tabindex="1" /><br />
						</label>

						<label class="conl">
							<strong><?php echo $lang_calendar['Date']?></strong><br />

							<select name="month" tabindex="2">
								<option value='0'><?php echo $lang_calendar['Month']?></option>
<?php
	$month_name = array('',$lang_calendar['January'],$lang_calendar['February'],$lang_calendar['March'],$lang_calendar['April'],$lang_calendar['May'],$lang_calendar['June'],$lang_calendar['July'],$lang_calendar['August'],$lang_calendar['September'],$lang_calendar['October'],$lang_calendar['November'],$lang_calendar['December']);
	for($x=1;$x<13;$x++)
	{
		$s = ($x == $date[1])? " selected='selected'" : NULL ;
		echo"\t\t\t\t\t\t\t\t<option value='".$x."'".$s.">".$month_name[$x]."</option>\n";
	}
?>
							</select>
						</label>
						<label class="conl"><br />
							<select name="day" tabindex="3">
								<option value='0'><?php echo $lang_calendar['Day']?></option>
<?php
	for($x=01;$x<=31;$x++)
	{
		$s = ($x == $date[2])? " selected='selected'" : NULL ;
		echo"\t\t\t\t\t\t\t\t<option value='".$x."'".$s.">".$x."</option>\n";
	}
?>
							</select>
						</label>
						<label class="conl"><br />
						<select name="year">
	
<?php
   $current_year = date("Y");

    for($x=($current_year-2);$x<=($current_year+5);$x++){

                        if ($x==$date[0]){
                        $slc = " selected='selected'";
                        }
                        else {
                        $slc = "";
                        }


        echo"<option value='".$x."'$slc>".$x."</option>\n";
        }
?>

							</select>

						</label>
						<br  class="clearer" />

						<div class="txtarea">
							<label class="conl">
								<strong><?php echo $lang_calendar['Body']?></strong><br />
								<textarea name="req_message" onkeydown="textCounter(this.form.req_message,this.form.remLen,20478);" rows="25" cols="70" style="width: 425px;"><?php echo str_replace('<br />',"\n",$event_list['body'])?></textarea><br />
							</label>
						<ul class="bblinks">
							<li><a href="help.php#bbcode" onclick="window.open(this.href); return false;"><?php echo $lang_common['BBCode'] ?></a>: <?php echo ($pun_config['p_message_bbcode'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#img" onclick="window.open(this.href); return false;"><?php echo $lang_common['img tag'] ?></a>: <?php echo ($pun_config['p_message_img_tag'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
							<li><a href="help.php#smilies" onclick="window.open(this.href); return false;"><?php echo $lang_common['Smilies'] ?></a>: <?php echo ($pun_config['o_smilies'] == '1') ? $lang_common['on'] : $lang_common['off']; ?></li>
						</ul>
						
						</div>
						<br class="clearer" />
					</div>
				</fieldset>
			</div>
			<p style="width: 450px;">
			<input type="hidden" name="page" value="<?php echo $_POST['page'];?>" />
			<input type="submit" value="<?php echo $lang_common['Submit'] ?>" /><a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a>
			</p>
		</form>
	</div>
	</div>

<?php  //this is a cludge, not the real thing used elsewhere
	if($CFG_show_cal == "yes"){
		echo "<div style='float:left;width:215px'>";
		mini_cal($date[1], $date[0], "week");
		echo "</div>";
	}
?>

<?php  //this is a cludge, not the real thing used elsewhere
	if($CFG_show_cal == "yes"){
		echo "<div style='float:right;width:215px'>";
		mini_cal($date[1]+3, $date[0], "week");
		echo "</div>";
	}
?>
	</div>
	</div>
	<br class="clearer" />
<?php
		}
		else
		{

			if(($pun_user['g_id'] == PUN_MOD && $CFG_mod_edit=='yes') || ($pun_user['g_id'] == "1"))
				$can_edit = "";
			else
				$can_edit = " WHERE user_id = ".$pun_user['id'];

			//Number of posts to display
			$disp_posts = $pun_user['disp_posts'];

			$result = $db->query('SELECT id FROM '.$db->prefix.'calendar'.$can_edit);
			$num_replies = $db->num_rows($result);

			// Determine the post offset (based on $_GET['p'])
			$num_pages = ceil(($num_replies) / $disp_posts);
			$p = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
			$start_from = $disp_posts * ($p - 1);

			$pages = paginate($num_pages, $p, 'calendar.php?action=edit');

			$result = $db->query('SELECT * FROM '.$db->prefix.'calendar '.$can_edit.' ORDER BY date LIMIT '.$start_from.','.$disp_posts) or error('Unable to fetch event information', __FILE__, __LINE__, $db->error());

			if(!$db->num_rows($result)){
				message($lang_calendar['no_events']);
			}

?>
	<form method="post" action="calendar.php?action=edit" onsubmit="return process_form(this)">
	<div class="blockform">
		<h2><?php echo $lang_calendar['edit_event']?></h2>
		<div class="box">
			<table cellspacing='0'>
			<thead>
				<tr>
					<th>&nbsp;</th>
					<th><?php echo $lang_calendar['Date']?></th>
					<th><?php echo $lang_calendar['Title']?></th>
					<?php if (($pun_user['g_id'] == PUN_MOD && $CFG_mod_edit=='yes') || ($pun_user['g_id'] == "1")) {echo "<th>".$lang_common['Username']."</th>\n";} ?>
					<th><?php echo $lang_calendar['Body'] ?></th>
				</tr>
			</thead>
			<tbody>
<?php

			while($event_list = $db->fetch_assoc($result))
			{
			    $tel = $tel + 1;
				$date_part = explode('-',$event_list['date']);
				$date_year = ($date_part['0']=='0000')?  date('y') : $date_part['0'];
				$date = date_str( mktime(0,0,0,$date_part['1'],$date_part['2'],$date_year));
				
				$preid = $event_list['user_id'];
	            $result_view = $db->query('SELECT id, username FROM '.$db->prefix.'users WHERE id='.intval($preid));
                $result_get = $db->fetch_assoc($result_view);
                $displayname = $result_get ['username'];
				
?>
				<tr>
					<td style="width:10px"><input type="radio" name="event" value="<?php echo $event_list['id']?>" /></td>
					<td style="width:85px"><?php echo $date ?></td> 
					<td style="width:145px"><?php echo pun_htmlspecialchars($event_list['title']) ?></td>
					<?php if (($pun_user['g_id'] == PUN_MOD && $CFG_mod_edit=='yes') || ($pun_user['g_id'] == "1")) {echo "<td>".$displayname."</td>\n";} ?>
					<td><?php echo str_replace('\n', '<br />',parse_message($event_list['body'], 0))?></td>
				</tr>
<?php
			}
?>
				<tr>
					<td colspan="<?php echo (($pun_user['g_id'] == PUN_MOD && $CFG_mod_edit=='yes') || ($pun_user['g_id'] == "1")) ? "5" : "4"; ?>">
						<input type="hidden" name="page" value="<?php echo $_GET['p'];?>" />
						<input type="hidden" name="tel" value="<?php echo $tel;?>" />
						<input type="submit" value="<?php echo $lang_calendar['edit_event']?>" name="edit_event" />&nbsp;<input type="submit" value="<?php echo $lang_calendar['delete_event']?>" name="delete_event" />&nbsp;<a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="calendar.php"><?php echo $lang_calendar['Back']; ?></a>
					</td>
				</tr>
			</tbody>
			</table>
		</div>
	</div>
	</form>
</div>
<div class="linksb">
	<div class="inbox">
		<p class="pagelink conl"><?php echo $lang_common['Pages'].': '.$pages?></p>
		<div class="clearer"></div>
	</div>
<?php
		}


	}
}
//
// Show the weekly calendar
//
elseif(isset($week))
{
	########################################################
	###//===============//===============//==============//#
	##//===============// Week Calendar //==============//##
	#//===============//===============//==============//###
	########################################################
	list($year,$week) = explode('.',$week);

	$date_offset = date('w', mktime(0,0,0,1,1,$year));
	$date_offset = ($date_offset < 5) ? 1-$date_offset : 8-$date_offset;
	$monday = mktime(0,0,0,1,1+$date_offset,$year);
	$date = strtotime('+' . ($week - 1) . ' weeks', $monday)-60*60*24;

	$month = date('n',$date);
	$week_start = $date-(60*60*24*1);
	$week_end = $week_start+(60*60*24*9);

	//previous week
	$year_link = date('Y', ($date + (60*60*24*4) - (60*60*24*7)));
	$date_link = date('W', ($date + (60*60*24*4) - (60*60*24*7)));

	//next week
	$year_link2 = date('Y', ($date + (60*60*24*4) + (60*60*24*7)));
	$date_link2 = date('W', ($date + (60*60*24*4) + (60*60*24*7)));

	$strdate = date("Y-m-d", $date);


	//change querys if $type is set to posts
	if($type == "posts")
	{
		//Find the topics made for "said" day
		$result = $db->query('SELECT t.posted 
FROM '.$db->prefix.'topics as t 
LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=t.forum_id AND fp.group_id='.$pun_user['g_id'].') 
WHERE t.posted > '.$week_start.' AND t.posted < '.$week_end.' 
AND (fp.read_forum IS NULL OR fp.read_forum=1)') 
OR error('Unable to fetch category/forum list', __FILE__, __LINE__, $db->error());
		$topic = array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
		while($topic_list = $db->fetch_row($result)){
			//Time zone adjustment
			$diff = ($pun_user['timezone'] - $server_timezone) * 3600;
			$topic_list[0] += $diff;
			
			$time = date("j",$topic_list[0]);
			$topic[$time]++;
		}


		//Find the posts made for "said" day (one month only)
		$result = $db->query('SELECT p.posted 
FROM '.$db->prefix.'posts AS p 
INNER JOIN '.$db->prefix.'topics AS t ON p.topic_id=t.id 
LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=t.forum_id AND fp.group_id='.$pun_user['g_id'].') 
WHERE p.posted > '.$week_start.' AND p.posted < '.$week_end.' 
AND (fp.read_forum IS NULL OR fp.read_forum=1)') 
OR error('Unable to fetch posts list', __FILE__, __LINE__, $db->error());
		$posts = array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
		while($post_list = $db->fetch_assoc($result)){
			//Time zone adjustment
			$diff = ($pun_user['timezone'] - $server_timezone) * 3600;
			$post_list['posted'] += $diff;
			
			$time = date('j',$post_list['posted']);
			$posts[$time]++;
		}
	}
	//change querys if $type is set to events
	elseif($type == "events")
	{
		//Find the birthdays for "said" day (selected week)
        if(date('m',$week_end) != date('m',$week_start))
            $strWhere = 'WHERE (MONTH(birthday) = '.$month.' and DAYOFMONTH(birthday) >= '.date('j',$week_start).') or (MONTH(birthday) = '.date('n',$week_end).' and DAYOFMONTH(birthday) <= '.date('j',$week_end).')';
        else
            $strWhere = 'WHERE MONTH(birthday) = '.$month.' and DAYOFMONTH(birthday) >= '.date('j',$week_start).' and DAYOFMONTH(birthday) <= '.date('j',$week_end);

		$strQuery = 'SELECT DAYOFMONTH(birthday) as day, username, MONTH(birthday) as month FROM '.$db->prefix.'users '.$strWhere;

		$result = $db->query($strQuery) or error('Unable to fetch birtday list', __FILE__, __LINE__, $db->error());
		$bdays = array('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		while($bday_list = $db->fetch_assoc($result)){
			if(count($bday_list)>6)
				$bdays[$bday_list['day']]++;
			else
				$bdays[$bday_list['day']] .="<img src='img/icon_party.gif' alt='Birthday' width='23' height='23' style='vertical-align: middle' /><a href='calendar.php?view=bday&amp;date=".$year.".".$bday_list['month'].".".$bday_list['day']."'>".$bday_list['username']."</a>&nbsp;&nbsp;";
		}

		//Find the events for "said" day (selected week)
		$strWhere = 'WHERE date >= "'.$strdate .'" AND date <= DATE_ADD("'.$strdate.'", INTERVAL 8 DAY ) ';
		$strQuery = 'SELECT id, title, DAYOFMONTH(date) as day, date FROM '.$db->prefix.'calendar '.$strWhere;
      		$result = $db->query($strQuery) or
		                  error('Unable to fetch calendar dates', __FILE__, __LINE__, $db->error());
		$dates = array('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		while($dates_list = $db->fetch_assoc($result)){
			$dates[$dates_list['day']] .= "*<a href='calendar.php?view=event&amp;date=".str_replace("-", ".", $dates_list['date'])."'>".$dates_list['title']."</a>&nbsp;&nbsp;";
		}
	}
?>
	<div style="width:100%;float:left;margin-right:-225px">
	<div style="margin-right:225px">

<?php

//BEGIN BUILD-LIST DATES IN THIS WEEK
	if($CFG_start_day == "S"){$a='0';$b='7';}
	elseif($CFG_start_day == "M"){$a='1';$b='8';}

    $today = time();
    $diff = ($pun_user['timezone'] - $pun_config['o_server_timezone']) * 3600;
	$today += $diff;
	if ($CFG_show_bday=="no"){ unset($bdays); }

	for ($x=$a; $x<$b; $x++) {
	        $datestamp = strtotime("+$x days", $date);
		$wk_name = $lang_calendar[date ('l', $datestamp)];
		$date_no = date('j', $datestamp);
		$mth_name = date('F', $datestamp);
		$year_name = date("Y", $datestamp);
        $month_no = date("n", $datestamp);

		if ($x == "0" || ($x == "1" && $b =="8")){
			echo "\t<h2><a href='calendar.php?".$ltype."date=".$year_name.".".$month_no."'>".$lang_calendar[$mth_name]." ".$year_name."</a></h2>\n\t<div class='box'>\n\t<table cellspacing='0'>\n";
		} elseif(date('d', $datestamp)=="1" ){
			echo "\t\t</table>\n\t</div>\n";
			echo "\t<h2><a href='calendar.php?".$ltype."date=".$year_name.".".$month_no."'>".$lang_calendar[$mth_name]." ".$year_name."</a></h2>\n\t<div class='box'>\n\t<table cellspacing='0'>\n";
		}

			if ($date_no == date('j', $today) && $mth_name == date('F') && $year_name == date('Y')) {
				$class = " class='calendar_day'";
			}
			elseif (!empty($bdays[$date_no])) {
			    // SPECIAL HIGHLIGHTING FOR B-DAYS
			    $class =" class='calendar_bday'";
			}
			elseif (!empty($dates[$date_no])) {
			    // SPECIAL HIGHLIGHTING FOR EVENTS
			    $class =" class='calendar_event'";
			}
			else {
			    $class = "";
			}

		echo "\t\t\t\t<tr><td valign='top' colspan='2' ".$class."><strong>".$wk_name."</strong></td></tr>\n";
		echo "\t\t\t\t<tr>\n\t\t\t\t\t<td valign='top' style='width:2%' ".$class.">".$date_no."</td>\n";
		echo "\t\t\t\t\t<td style='width:97%' ".$class.">";

// LIST COLLECTION FOR INDIVIDUAL DAYS IN CALENDAR
		if(!empty($topic[$date_no]))echo"<a href='calendar.php?view=topics&amp;date=".$year.".".$month_no.".".$date_no."'>".$lang_calendar['Topics']." ".$topic[$date_no]."</a>&nbsp;&nbsp;|&nbsp;&nbsp;";

		if(!empty($posts[$date_no]))echo"<a href='calendar.php?view=posts&amp;date=".$year.".".$month_no.".".$date_no."'>".$lang_calendar['Posts']." ".$posts[$date_no]."</a>&nbsp;&nbsp;|&nbsp;&nbsp;";

		if(!empty($bdays[$date_no]) && !is_int($bdays[$date_no]))
			echo $bdays[$date_no];
		elseif(!empty($bdays[$date_no]) && is_int($bdays[$date_no]))
				echo $bdays[$date_no];

			if(!empty($dates[$date_no]))
				echo $dates[$date_no];
		
		echo "&nbsp;</td>\n\t\t\t\t</tr>\n\n";
	}
?>
				<tr>
					<td colspan="2"><div style="float:left">
<?php					echo "<a href=\"calendar.php?".$ltype."week=".$year_link.".".$date_link."\" rel=\"nofollow\">".$lang_calendar['Last Week']."</a> | ";
					echo "<a href=\"calendar.php?".$ltype."week=".$year_link2.".".$date_link2."\" rel=\"nofollow\">".$lang_calendar['Next Week']."</a></div>"; ?>
<?php if($CFG_show_typelist=="yes") { ?>
					<div style="float:right">
                                                <form id="date" method="post" action="calendar.php?week=<?php echo $_GET['week']?>">
                                                        <div style="float:left">
                                                                <select name="type" onchange="document.forms['date'].submit()">
                                                                        <option value="posts"<?php if($type=="posts")echo" selected='selected'"?>><?php echo $lang_calendar['posts/topics']?></option>
                                                                        <option value="events"<?php if($type=="events")echo" selected='selected'"?>><?php echo $lang_calendar['events']?></option>
                                                                </select>

                                                        </div>
                                                </form>
                                 </div>
<?php } ?>
                                      &nbsp;</td>
				</tr>

			</table>
		</div>

<?php	if(
			($pun_user['g_id'] == PUN_MOD && $CFG_mod_add=='yes') || 
	        ($pun_user['g_id'] != PUN_GUEST && $CFG_user_add == 'yes' && $pun_user['g_id'] != PUN_MOD) || 
			($pun_user['g_id'] == PUN_ADMIN)
		)
		echo "\t<br />\n\t<div class='box'><p>&nbsp;<a href='calendar.php?action=add'>".$lang_calendar['Add_event']."</a> | <a href='calendar.php?action=edit'>".$lang_calendar['Edit_event']."</a></p></div>\n";
?>
</div>
	</div>

<?php	if($CFG_show_cal == "yes"){
	echo "<div style='float:right;width:215px'>";
        mini_cal($month_no, $year_name, "week");
        echo "</div>";
        }
?>

	<br class="clearer" />


<?php

}
//
//
//if $actions, $view or $week isnt set
//
else
{
	#########################################################
	###//===============//===============//===============//#
	##//===============// Main Calendar //===============//##
	#//===============//===============//===============//###
	#########################################################

	//change querys if $type is set to posts
	if($type == "posts")
	{

		//Time zone adjustment
		$diff = (($pun_user['timezone'] - $server_timezone) * 3600)*(-1);
		$month_start += $diff;
		$month_end += $diff;

		//Find the topics made for "said" day
		$result = $db->query('SELECT t.posted FROM '.$db->prefix.'topics as t LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=t.forum_id AND fp.group_id='.$pun_user['g_id'].') WHERE t.posted > '.$month_start.' AND t.posted < '.$month_end.' AND (fp.read_forum IS NULL OR fp.read_forum=1)') or error('Unable to fetch category/forum list', __FILE__, __LINE__, $db->error());
		$topic = array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
		while($topic_list = $db->fetch_row($result)){
			//Time zone adjustment
			$diff = ($pun_user['timezone'] - $server_timezone) * 3600;
			$topic_list[0] += $diff;
			
			$time = date("j",$topic_list[0]);
			$topic[$time]++;
		}

		//Find the posts made for "said" day
		$result = $db->query('SELECT p.posted FROM '.$db->prefix.'posts AS p INNER JOIN '.$db->prefix.'topics AS t ON p.topic_id=t.id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=t.forum_id AND fp.group_id='.$pun_user['g_id'].') WHERE p.posted > '.$month_start.' AND p.posted < '.$month_end.' AND (fp.read_forum IS NULL OR fp.read_forum=1)') or error('Unable to fetch posts list', __FILE__, __LINE__, $db->error());
		$posts = array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
		while($post_list = $db->fetch_assoc($result)){
			//Time zone adjustment
			$diff = ($pun_user['timezone'] - $server_timezone) * 3600;
			$post_list['posted'] += $diff;
			
			$time = date('j',$post_list['posted']);
			$posts[$time]++;
		}

	}
	//change querys if $type is set to events
	elseif($type == "events")
	{

		//Find the birthdays for "said" day
		$result = $db->query('SELECT DAYOFMONTH(birthday) as day, username FROM '.$db->prefix.'users WHERE MONTH(birthday) = '.$month) or error('Unable to fetch birtday list', __FILE__, __LINE__, $db->error());
		$bdays = array('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		while($bday_list = $db->fetch_assoc($result)){
			if(count($bday_list)>3)
				$bdays[$bday_list['day']]++;
			else
                                $bdays[$bday_list['day']] .="<img src='img/icon_party.gif' alt='Birthday' width='23' height='23' style='vertical-align: middle' /><a href='calendar.php?view=bday&amp;date=".$year.".".$month.".".$bday_list['day']."'>".$bday_list['username']."</a><br />";
		}

		//Find the events for "said" day
		$result = $db->query('SELECT id, title, DAYOFMONTH(date) as day FROM '.$db->prefix.'calendar WHERE MONTH(date) = '.$month.' AND (YEAR(date) = '.$year.' OR YEAR(date) = "0000")') or error('Unable to fetch calendar dates', __FILE__, __LINE__, $db->error());
		$dates = array('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		while($dates_list = $db->fetch_assoc($result)){
			$dates[$dates_list['day']] .= "<a href='calendar.php?view=event&amp;date=".$year.".".$month.".".$dates_list['day']."'>".$dates_list['title']."</a><br />";
		}


	}
?>
	<h2 style="text-align:center">
		<span>
                     <!--   <a href="calendar.php?<?php echo $ltype?>date=<?php echo ($year-1).'.'.$month;?>">&lt;&ndash;</a> -->
                        <a href="calendar.php?<?php echo $ltype?>date=<?php if($month == 1){echo $year-1;}else{echo$year;}?>.<?php if($month == 1){echo '12';}else{echo $month-1;}?>" rel="nofollow">&lt;&lt;&mdash;</a>
			<?php echo $lang_calendar[$monthtext]." ".$year."\n" ?>
                        <a href="calendar.php?<?php echo $ltype?>date=<?php if($month == 12){echo $year+1;}else{echo$year;}?>.<?php if($month == 12){echo '1';}else{echo $month+1;}?>" rel="nofollow">&mdash;&gt;&gt;</a>
                     <!--   <a href="calendar.php?<?php echo $ltype?>date=<?php echo ($year+1).'.'.$month;?>">&ndash;&gt;</a> -->
		</span>
	</h2>
	<div class="box">
		<table cellspacing="0">
		<thead>
			<tr>
<?php if($CFG_start_day == "S"):?>				<th><?php echo $lang_calendar['Sunday']?></th>
<?php endif;?>				<th><?php echo $lang_calendar['Monday']?></th>
				<th><?php echo $lang_calendar['Tuesday']?></th>
                                <th><?php echo $lang_calendar['Wednesday']?></th>
				<th><?php echo $lang_calendar['Thursday']?></th>
				<th><?php echo $lang_calendar['Friday']?></th>
				<th><?php echo $lang_calendar['Saturday']?></th>
<?php if($CFG_start_day == "M"):?>				<th><?php echo $lang_calendar['Sunday']?></th>
<?php endif;?>
				<th class='calendar_wk'>&nbsp;</th>
			</tr>
		</thead>
		<tbody>
			<tr>
<?php

//NOW BUILD EACH DAY PARSING LISTS INTO EACH
		if ($day_of_wk <> 0){
			for ($i=0; $i<$day_of_wk; $i++)
			{ echo "\t\t\t\t<td valign='top' style='width:14%; height:75px' class='calendar_no' >&nbsp;</td>\n"; }
		}
		
		    $today = time();
            $diff = ($pun_user['timezone'] - $pun_config['o_server_timezone']) * 3600;
	        $today += $diff;
	        if ($CFG_show_bday=="no"){ unset($bdays); }

		for ($date_of_mth = 1; $date_of_mth <= $days_in_mth; $date_of_mth++) {

			$date_no = date("j", mktime(0, 0, 0, $month, $date_of_mth, $year));
			$day_of_wk = start_date(date('w', mktime(0, 0, 0, $month, $date_of_mth, $year)));
			if (($date_no ==  date("j", $today) &&  $month == date("n") && $year == date("Y"))) {
				$class = " class='calendar_day'";
			}
			elseif (!empty($bdays[$date_no])) {
			    // SPECIAL HIGHLIGHTING FOR B-DAYS
			    $class =" class='calendar_bday'";
			}
			elseif (!empty($dates[$date_no])) {
			    // SPECIAL HIGHLIGHTING FOR EVENTS
			    $class =" class='calendar_event'";
			}
			else {
			    $class = "";
			}
			

	if(
		(($pun_user['g_id'] == PUN_MOD && $CFG_mod_add=='yes') ||
		($pun_user['g_id'] != PUN_GUEST && $CFG_user_add == 'yes' && $pun_user['g_id'] != PUN_MOD) ||
		($pun_user['g_id'] == PUN_ADMIN)) &&
		($type=="events")
	) {
			echo "\t\t\t\t<td valign='top' style='width:14%; height:75px'".$class."><span><a href='calendar.php?action=add&amp;date=".$year.".".$month.".".$date_no."' style='text-decoration:none'>".$date_no."</a></span><br />";
	  }
    else {
			echo "\t\t\t\t<td valign='top' style='width:14%; height:75px'".$class."><span>".$date_no."</span><br />";
    }

// LIST COLLECTION FOR INDIVIDUAL DAYS IN CALENDAR
			if(!empty($topic[$date_no]))echo"<a href='calendar.php?view=topics&amp;date=".$year.".".$month.".".$date_no."'>".$lang_calendar['Topics']." ".$topic[$date_no]."</a><br />";

			if(!empty($posts[$date_no]))echo"<a href='calendar.php?view=posts&amp;date=".$year.".".$month.".".$date_no."'>".$lang_calendar['Posts']." ".$posts[$date_no]."</a><br />";

			if(!empty($bdays[$date_no]) && !is_int($bdays[$date_no]))
				echo $bdays[$date_no];
			elseif(!empty($bdays[$date_no]) && is_int($bdays[$date_no]))
				echo $bdays[$date_no];

			if(!empty($dates[$date_no]))
				echo $dates[$date_no]."<br />";

			echo "</td>\n";
			
			$year_link = date('Y', mktime(0,0,0,$month,(($CFG_start_day == "S") ? ($date_no - $day_of_wk + 4) : ($date_no - $day_of_wk + 3)),$year));
			$date_link = date('W', mktime(0,0,0,$month,(($CFG_start_day == "S") ? ($date_no - $day_of_wk + 4) : ($date_no - $day_of_wk + 3)),$year));
			
			if ( $day_of_wk == 6 )
			{
			
				echo "\t\t\t\t<td class='calendar_wk'><a href='calendar.php?".$ltype."week=".$year_link.".".$date_link."'>&laquo;</a></td>\n";

				echo "\t\t\t</tr>\n\t\t\t<tr>\n";
			}
			if ( $day_of_wk < 6 && $date_of_mth == $days_in_mth ) {

				for ( $i = $day_of_wk ; $i < 6; $i++ )
				{ echo "\t\t\t\t<td valign='top' style='width:14%; height:75px' class='calendar_no' >&nbsp;</td>\n"; }
				
				echo "\t\t\t\t<td class='calendar_wk'><a href='calendar.php?".$ltype."week=".$year_link.".".$date_link."'>&laquo;</a></td>\n";
				echo "\t\t\t</tr>\n\t\t\t<tr>\n";
			}
		}
?>
				<td colspan="8">
					<div style="float:left; padding-top:5px; padding-right:3px"><?php echo $lang_calendar['go_to']?></div>
					<form id="date" method="post" action="calendar.php">
						<div style="float:left">
							<select name="month">
<?php
				$month_name = array($lang_calendar['January'],$lang_calendar['February'],$lang_calendar['March'],$lang_calendar['April'],$lang_calendar['May'],$lang_calendar['June'],$lang_calendar['July'],$lang_calendar['August'],$lang_calendar['September'],$lang_calendar['October'],$lang_calendar['November'],$lang_calendar['December']);
				for($x=00;$x<12;$x++)
				{
					$z = $x+1;
					echo"\t\t\t\t\t\t\t\t<option value='".$z."'";
					if($month == $z)echo" selected='selected'";
					echo">".$month_name[$x]."</option>\n";
				}
?>
							</select>
							<select name="year">
<?php
                $current_year = date("Y");
                
                for($x=($current_year-2);$x<=($current_year+5);$x++) {
 
                        if ($x==$year){
                        $slc = " selected='selected'";
                        }
                        else {
                        $slc = "";
                        }

                     echo"\t\t\t\t\t\t\t\t<option value='".$x."'$slc>".$x."</option>\n";
                }

?>
							</select>
                                                        <input type="submit" value="<?php echo $lang_calendar['go'] ?>" />
						</div>
						<div style="float:left; padding-top:5px; padding-left:3px">&nbsp;
							<a href="calendar.php?date=<?php echo date('Y.m')?>"><?php echo $lang_calendar['current_month'];?></a>&nbsp;
							<a href="calendar.php?week=<?php echo date('Y.W')?>"><?php echo $lang_calendar['current_week'];?></a>
						</div>
<?php if($CFG_show_typelist=="yes") { ?>
                                              <div style="float:right">
                                                        <select name="type" onchange="document.forms['date'].submit()">
                                                                <option value="posts"<?php if($type=="posts")echo" selected='selected'"?>><?php echo $lang_calendar['posts/topics']?></option>
                                                                <option value="events"<?php if($type=="events")echo" selected='selected'"?>><?php echo $lang_calendar['events']?></option>
                                                        </select>
                                                </div>
<?php } ?>
					</form>
				</td>
			</tr>
		</tbody>
		</table>
	</div>
<?php
// SHOULD THE LITTLE MINICALS BE DISPLAYED AT THE BOTTOM OF THE PAGE? 
	if($CFG_show_cal == "yes"){
		echo"\t<br />\n\t<table cellspacing='0'>\n\t<tr>\n\t\t<td valign='top' style='border:none;padding:0 5px 0 0; margin:0'>\n";
		mini_cal($month, $year, 'main');
		echo "\t\t</td>\n\t</tr>\n\t</table>\n";
	}
// IF THE USER IS OK, SHOW THE EVENT ADD/EDIT CONTROLS
	if(
		($pun_user['g_id'] == PUN_MOD && $CFG_mod_add=='yes') ||
		($pun_user['g_id'] != PUN_GUEST && $CFG_user_add == 'yes' && $pun_user['g_id'] != PUN_MOD) ||
		($pun_user['g_id'] == PUN_ADMIN)
	)
	echo "\t<br />\n\t<div class='box'><p>&nbsp;<a href='calendar.php?action=add'>".$lang_calendar['Add_event']."</a> | <a href='calendar.php?action=edit'>".$lang_calendar['Edit_event']."</a></p></div>\n";
}
?>
</div>
<?php require PUN_ROOT.'footer.php';?>
