<?php

// Load the needed files (calendar config, lang)
require PUN_ROOT.'calendar/config.php';
require PUN_ROOT.'lang/'.$pun_user['language'].'/calendar.php';

$days_in_mth = date("t", mktime(0, 0, 0, $month, 1, $year)) ;
$dayfull = date("jS", mktime(0, 0, 0, $month, $day, $year));
$monthtext = date("F", mktime(0, 0, 0, $month, 1, $year));
$day_text = date("D", mktime(0, 0, 0, $month, 1, $year));
$day_of_wk = start_date(date('w', mktime(0, 0, 0, $month, 1, $year)));

$type = (isset($_REQUEST['type']))? $_REQUEST['type'] : $CFG_start_view ;
$ltype = 'type='.$type.'&amp;';
$view = (isset($_GET['view']))? $_GET['view'] : NULL ;
$action = (isset($_GET['action']))? $_GET['action'] : NULL ;
$week = (isset($_GET['week']))? $_GET['week'] : NULL ;

$month_start = mktime(0,0,0,$month,1,$year);
$month_end = mktime(23,59,59,$month,$days_in_mth,$year);
$datestart = mktime(0,0,0,$month,$day,$year);
$dateend = mktime(23,59,59,$month,$day,$year);

/*====================*/
$date_format = $lang_calendar['Date_format'];
if ($date_format == 'US') {
   $datestring = $monthtext." ".$dayfull." ".$year;
} else {
   $datestring = $day." ".$lang_calendar[$monthtext]." ".$year;
}

/*====================*/
/*=  date_str        =*/
/*====================*/

function date_str($datestamp){
   global $lang_calendar;

   if ($lang_calendar['Date_format'] == 'US') {
      return date("M jS Y", $datestamp);
   } else {
      return (date("j ", $datestamp)).($lang_calendar[(date("M", $datestamp))]).(date(" Y", $datestamp));
   }
}

/*====================*/
/*= Change Start Day =*/
/*====================*/
function start_date($date){
    global $CFG_start_day;

    if($CFG_start_day == "M"){
        switch($date) {
            case 0:
                $start = 6;
                break;
            default:
                $start = $date -1;
                break;
        }
    }elseif($CFG_start_day == "S")
        $start = $date;

    return $start;
}

/*=======================*/
/*= Navigation Function =*/
/*=======================*/
function navigation($type){
global $lang_calendar,$lang_common,$day,$month,$year,$pages;

$lastday    = date("Y.n.j", mktime(0, 0, 0, $month, ($day-1), $year));
$lastweek = date("Y.n.j", mktime(0, 0, 0, $month, ($day-7), $year));
$lastmonth= date("Y.n.j", mktime(0, 0, 0, ($month-1), $day, $year));
$nextday    = date("Y.n.j", mktime(0, 0, 0, $month, ($day+1), $year));
$nextweek = date("Y.n.j", mktime(0, 0, 0, $month, ($day+7), $year));
$nextmonth= date("Y.n.j", mktime(0, 0, 0, ($month+1), $day, $year));
?>
</div>

<?php if(isset($pages)){?>
<div class="linksb">
    <div class="inbox">
        <p class="pagelink conl"><?php echo $lang_common['Pages'].': '.$pages?></p>
        <div class="clearer"></div>
    </div>
</div>
<?php }?>

<div class="blocktable">

<?php }


/*=================*/
/*= Mini Calendar =*/
/*=================*/
function mini_cal($month, $year, $place){
global $db, $pun_user, $CFG_start_day, $lang_calendar, $type;

        for($X=($month); $X<=($month); $X++)
        {
                        $month_start = mktime(0,0,0,$X,1,$year);
                        $day_in_mth = date("t", $month_start);
                        $monthtext  = date("F", $month_start);
                        $day_text   = date("D", $month_start);
                        $month_year = date("Y", $month_start);
                        $month_no   = date("n", $month_start);

                        $day_of_wk  = start_date(date("w", $month_start));
                        $month_end  = mktime(23,59,59,$X,$day_in_mth,$year);

		//Find the birthdays for "said" day
		$result = $db->query('SELECT DAYOFMONTH(birthday) as day FROM '.$db->prefix.'users WHERE MONTH(birthday) = '.$month_no) or error('Unable to fetch birtday list', __FILE__, __LINE__, $db->error());
		$bdays = array('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
		while($bday_list = $db->fetch_assoc($result))
		{
			if ($bday_list['day'] != $bday_list_prev)
				$bdays[$bday_list['day']] .="<a href='calendar.php?view=bday&amp;date=".$month_year.".".$month_no.".".$bday_list['day']."'>".$bday_list['day']."</a><br />";
			
			$bday_list_prev = $bday_list['day'];
		};

        //Find the events for "said" day
        $result = $db->query('SELECT id, title, DAYOFMONTH(date) as day FROM '.$db->prefix.'calendar WHERE MONTH(date) = '.$month_no.' AND (YEAR(date) = '.$month_year.' OR YEAR(date) = "1900")') or error('Unable to fetch calendar dates', __FILE__, __LINE__, $db->error());
        $dates = array('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
        while($dates_list = $db->fetch_assoc($result)){
            $dates[$dates_list['day']] = "<a href='calendar.php?view=event&amp;date=".$month_year.".".$month_no.".".$dates_list['day']."'>".$dates_list['day']."</a><br />";
        };


?>
            <h2><span><a href="calendar.php?date=<?php echo $month_year.".".$month_no ?>"><?php echo $lang_calendar[$monthtext]?></a></span></h2>
            <div class="box">
                <table cellspacing="0">
                <thead>
                    <tr>
<?php 
                if($place == 'main'){
                    if($CFG_start_day == "S")echo "\t\t\t\t\t\t<th>".$lang_calendar['Sun']."</th>\n";
                    echo "\t\t\t\t\t\t<th>".$lang_calendar['Mon']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Tue']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Wed']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Thu']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Fri']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Sat']."</th>\n";
                    if($CFG_start_day == "M")echo "\t\t\t\t\t\t<th>".$lang_calendar['Sun']."</th>\n";
                }
                elseif($place == 'week'){
                                        if($CFG_start_day == "S")echo "\t\t\t\t\t\t<th>".$lang_calendar['Su']."</th>\n";
                                        echo "\t\t\t\t\t\t<th>".$lang_calendar['Mo']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Tu']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['We']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Th']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Fr']."</th>\n\t\t\t\t\t\t<th>".$lang_calendar['Sa']."</th>\n";
                                        if($CFG_start_day == "M")echo "\t\t\t\t\t\t<th>".$lang_calendar['Su']."</th>\n";
                }
?>
                    </tr>
                </thead>
                <tbody>
                    <tr>
<?php 
                if ($day_of_wk <> 0){for ($i=0; $i<$day_of_wk; $i++){ echo "\t\t\t\t\t\t<td class='calendar_no'>&nbsp;</td>\n"; }}

                for ($date_of_mth = 1; $date_of_mth <= $day_in_mth; $date_of_mth++) {

                                        $date_stamp = mktime(0, 0, 0, $X, $date_of_mth, $year);
                                        $date_no = date("j", $date_stamp);
                                        $day_of_wk = start_date(date("w", $date_stamp));

                    $class = ($date_no ==  date("j") &&  $month_no == date("n") && $month_year == date("Y"))? " class='calendar_day'" :'';
					if (!empty($bdays[$date_no])) {
					       $class =" class='calendar_bday'";
					       echo "\t\t\t\t\t\t<td".$class.">".$bdays[$date_no]."</td>\n";
					} else
                    if (!empty($dates[$date_no])) {
                           $class =" class='calendar_event'";
                           echo "\t\t\t\t\t\t<td".$class.">".$dates[$date_no]."</td>\n";
                    } else
                        echo "\t\t\t\t\t\t<td".$class.">".$date_no."</td>\n";


                    if ( $day_of_wk == 6 )
                        echo "\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n";

                    if ( $day_of_wk < 6 && $date_of_mth == $day_in_mth )
                        for ( $i = $day_of_wk ; $i < 6; $i++ ) echo "\t\t\t\t\t\t<td class='calendar_no'>&nbsp;</td>\n";

                }
?>
                    </tr>
                </tbody>
                </table>
            </div>
<?php 

                if($place == 'main' && $X==($month-1))
                {
                    echo "\t\t</td><td valign='top' style='border:none;padding:0; margin:0'>\n";
                    $X=($month);
                }
                elseif($place == 'week')
                    echo "\t\t<br />\n";

        }
}

//get current month and year
$month_no = date("n");
$year = date("Y");

//show mini calendar
?>        <div style='float:right; width:215px'><?php mini_cal($month_no, $year, "week"); ?></div><?php

?>